{$I ETKKS.DEF}
{$O+,F+}
Unit ETK_Rpt;
Interface
Uses WinDos, ListStrc, ETK_Mess;

{   }
Type TReport=(rptOverdue,rptChannels,rptDirections,rptSIT,rptTariff,rptConfirm,rptRegions);
     TReportSet=Set Of TReport;

     TReportKind=Record
     Reports:TReportSet;
     StartDate,EndDate:TDateTime;
     End;

Type {ꥪ - ॣ  䨪}
  PRegionsTrafficList = ^TRegionsTrafficList;
  TRegionsTrafficList = object(TList)
    PItems:PList;
    procedure LoadList; virtual;
    procedure Start;
    procedure Stop;
    procedure Add(Sys:SystemMessageRec; Date:String);
    procedure Print;
    destructor Done; virtual;
  private
    function Region(Index:String):String;
  end;

Var  ReportKind:TReportKind;
     PRegionsTraffic:PRegionsTrafficList; {᮪ ॣ  䨪}

Procedure MakeReport;
Procedure StopReport;                  { ⠭  }
Procedure IdleReport;                  {    Idle }

Implementation
Uses Crt,App,SApp,Objects,Drivers,Printer,DOS,ETK_Disk,ETK_Arc,ETK_Draw,
     ETK_Dir,ETK_Chan,TV_Supp,ETK_Data,
     SGraph,SViews,ETK_PRN,TVDate,ConvInfo,SDialogs,

{$IFDEF ATK16}  ETK_Dr16;
{$ELSE }        ETK_Dr08;
{$ENDIF}


Var ReportInd:PProcess;                 {  }

         {᪨ ஢ ⫣, ࠡ⠭  ⥣ 樨 }
    PNumber1,                           { -⮨ }
    PNumber2,                           { - }
    PNumber3:PNumberCollection;         { - ஢ }
    OverNumbers:PNumberCollection;
    NoConfirm:PNumberCollection;
    DateCollection:PStringCollection;

    OfDeleted,                          {  }
    TotalInput,                         { ᥣ ਭ }
    TotalOutput,                        { ᥣ । }
    TotalTariffTLG,
    TotalSIT,
    OverR,OverA,OverS,OverP,OverB:LongInt; { ᥣ   ⥣ }
    CurrentExpl:String[20];

{}
{- ꥪ  ଠ樨, 㯯饩  ᯫ./⮮⢥  -}
{-    䨪   ࠢ,  ஢          -}
{    - 䨪                               }
{   ࠢ - 䨪 ࠢ                                        }
{    - ᯨ᮪ ஢                                       }
{}
Type PStatItem=^TStatItem;
     TStatItem=Object(TObject)
        Expl:String[20];       {ᯫ  / ⮮⢥ (䨪 㯯)}
        Reply:String[20];

        {- 䨪 -}
        InpR,OutR,
        InpA,OutA,
        InpS,OutS,
        InpP,OutP,
        InpB,OutB,
        InpSSS,OutSSS:LongInt;           { ਭ / । }

        StartInpNum,EndInpNum,
        StartInpNum1,EndInpNum1,
        StartOutNum,EndOutNum,
        StartOutNum1,EndOutNum1:LongInt;

        {- 䨪 -}
        TariffColl:PCollection; { ᮪ ଠ樨  ⫣   }
        TotalAccount:LongInt;   { ⮨    }
        TotalNDS:LongInt;
        TotalTariff:LongInt;

        Constructor Init(AExpl,AReply:String);
        Destructor  Done;  Virtual;

        Procedure   UpdateIn(InpNum:Word);    { "" ஢ /}
        Procedure   UpdateOut(OutNum:Word);
     End;


{}
{- ନ㥬 ᯨ᮪ ଠ樨  䨪  䨪樨 -}
{}
Type PStatColl=^TStatColl;
     TStatColl=Object(TSortedCollection)
     { ਭ⮩}
      Procedure AddInput(Expl:String;Cat:String; InpNum:Word);
     { ।}
      Procedure AddOutput(Expl:String;Cat:String; OutNum:Word);
     { ஢}
      Procedure AddTariff(Reply,ExplIn:String; NumArc:LongInt;NumWords:Word; Account,NDS:LongInt;
                          OutIndex:String; DateTime:DateTimeRec);

         private
        Function  CheckExist(Expl,Reply:String):PStatItem;
        Function Compare(Key1, Key2: Pointer): Integer; virtual;
      End;

Var DirStat,ChanStat,TariffStat:PStatColl;

{}

Type TBuff=Array[1..1]Of Byte;

Var
    Buffer:^TBuff;
    BufferPos:LongInt;

Procedure AddBufferLine(S:String);
Const VKPS:String=#13#10;
Begin
  If Not Assigned(Buffer) Then Exit;

  Move(S[1],Buffer^[BufferPos],Length(S)); Inc(BufferPos,Length(S));
  Move(VKPS[1],Buffer^[BufferPos],2);      Inc(BufferPos,2);


  If BufferPos>9000
  Then Begin
       If Assigned(ReportWindow)
       Then ReportWindow^.AddBuffer(Buffer,Pred(BufferPos));
       BufferPos:=1;
       End
End;


Function TrimLeft(S:String):String;
Begin
 While S[1]=' ' do Delete(S,1,1);
 TrimLeft:=S;
End;

Function AddLeft(S:String; Count:Byte):String;
Var I:Word;
Begin
  For I:=1 to Count do S:=' '+S;
  AddLeft:=S;
End;

Function AddRight(S:String; Count:Byte):String;
Begin
  While Length(S)<Count do S:=S+' ';
  AddRight:=S;
End;

Constructor TStatItem.Init;
Begin
  Inherited Init;
  TariffColl:=New(PCollection,Init(10,10));
  Expl:=AExpl;
  Reply:=AReply;
  InpS:=0;OutS:=0;
  InpP:=0;OutP:=0;

  StartInpNum:=$FFFF; EndInpNum:=$FFFF;
  StartInpNum1:=9999; EndInpNum1:=0;
  StartOutNum:=$FFFF; EndOutNum:=$FFFF;
  StartOutNum1:=9999; EndOutNum1:=0;

  OverR:=0; OverA:=0;
  OverS:=0; OverP:=0;
  OverB:=0;
End;

Destructor TStatItem.Done;
Begin
  TariffColl^.FreeAll;
  Dispose(TariffColl,Done);
  Inherited Done;
End;

Procedure TStatItem.UpdateIn;
Begin
  If InpNum = 0 Then Exit;

  If (InpNum<StartInpNum) or (StartInpNum=$FFFF)    Then StartInpNum:=InpNum;
  If (InpNum>EndInpNum)   or (EndInpNum=$FFFF)      Then EndInpNum:=InpNum;

  If (InpNum>=5000)       and (InpNum<StartInpNum1) Then StartInpNum1:=InpNum;
  If (InpNum<5000)        and (InpNum>EndInpNum1)   Then EndInpNum1:=InpNum;
End;

Procedure TStatItem.UpdateOut;
Begin
  If OutNum = 0 Then Exit;

  If (OutNum<StartOutNum) or (StartOutNum=$FFFF)    Then StartOutNum:=OutNum;
  If (OutNum>EndOutNum)   or (EndOutNum=$FFFF)      Then EndOutNum:=OutNum;

  If (OutNum>=5000)       and (OutNum<StartOutNum1) Then StartOutNum1:=OutNum;
  If (OutNum<5000)        and (OutNum>EndOutNum1)   Then EndOutNum1:=OutNum;
End;

{}

Type PTariffItem=^TTariffItem;
     TTariffItem=Object(TObject)
     NumArc:LongInt;NumWords:Word;
     DateTime:DateTimeRec;
     Account:LongInt;
     NDS:LongInt;
     Tariff:LongInt;
     OutIndex:String[9];
     Constructor Init(AN:LongInt;AWords:Word; AAccount,ANDS:LongInt; MIndex:String; isDateTime:DateTimeRec);
     End;

Constructor TTariffItem.Init;
Begin
  Inherited Init;
  NumArc:=AN;
  NumWords:=AWords;
  NDS:=ANDS;
  Account:=AAccount;
  Tariff:=Round((Account-NDS)/100)*100;
  DateTime:=isDateTime;
  OutIndex:=MIndex;
End;

{}

Function TStatColl.CheckExist;
Var P:PStatItem;
    I:Word;
Begin
  CheckExist:=NIL;
  For I:=1 to Count do
  Begin
    P:=At(I-1);
    If P^.Expl=Expl
    Then Begin
         If (Reply<>'') and (Reply<>P^.Reply) Then Continue;
         CheckExist:=P;
         Break;
         End;
  End;
End;

Function TStatColl.Compare;
Var K1:PStatItem Absolute Key1;
    K2:PStatItem Absolute Key2;
Begin
  If K1^.Reply < K2^.Reply
  Then Compare:=-1
  Else Compare:=1;
End;

Procedure TStatColl.AddInput;
Var P:PStatItem;
Begin
  P:=CheckExist(Expl,'');
  If P=NIL
  Then Begin
       P:=New(PStatItem,Init(Expl,Expl));
       Insert(P);
       End;

  If Cat='' Then Inc(P^.InpSSS)
  Else Case Cat[1] of
         '': Inc(P^.InpR);
         '': Inc(P^.InpA);
         '': Inc(P^.InpS);
         '': Inc(P^.InpP);
         '': Inc(P^.InpB);
         End;

  P^.UpdateIn(InpNum);
End;

Procedure TStatColl.AddOutput;
Var P:PStatItem;
Begin
  P:=CheckExist(Expl,'');
  If P=NIL
  Then Begin
       P:=New(PStatItem,Init(Expl,Expl));
       Insert(P);
       End;

  If Cat='' Then Inc(P^.OutSSS)
  Else Case Cat[1] of
         '': Inc(P^.OutR);
         '': Inc(P^.OutA);
         '': Inc(P^.OutS);
         '': Inc(P^.OutP);
         '': Inc(P^.OutB);
         End;

  P^.UpdateOut(OutNum);
End;

Procedure TStatColl.AddTariff;
Var P:PStatItem;
Begin
  P:=CheckExist(Reply,ExplIn);
  If P=NIL
  Then Begin
       P:=New(PStatItem,Init(Reply,ExplIn));
       Insert(P);
       End;

  Inc(P^.TotalTariff,Account);
  P^.TotalNDS:=Round(P^.TotalTariff/100) * NDS;
  P^.TotalAccount := Round (P^.TotalTariff/100)*100 +P^.TotalNDS;

  Inc(TotalTariffTLG);
  P^.TariffColl^.Insert(New(PTariffItem,Init(NumArc,NumWords,Account,NDS,OutIndex,DateTime)));
End;

{}

Type TReportStage=(rptNone,rptScanning,rptPrintCaption,rptPrint);

Var ReportStage:TReportStage;     { 饥 ﭨ   }
    CurrentReport:TReport;        {   }
    CurrentDatePTR:PString;

    StartArchiveDate,
    StopArchiveDate,
    CurrentArchiveDate:Date;      {}

    CurrentArchive:String;        {  ᪠㥬 娢 }
    CurrentItem:LongInt;          {   ᪠㥬 䠩 娢 }
    ArcItem:ArcItemRec;
    Date:String;


Procedure StartReport;                 {    }
Var PChan:PChannel;
    PDir:PDirection;
    R:TRect;
Begin
  Date:=GetDateFileName(StartArchiveDate);
  CurrentArchive:=GetJnlPath(Date,IsNet);

  StopReport;

  DirStat:=New(PStatColl,Init(10,10));
  ChanStat:=New(PStatColl,Init(10,10));
  TariffStat:=New(PStatColl,Init(10,10));

  PRegionsTraffic^.Start;

  PNumber1:=New(PNumberCollection,Init(10,10));    PNumber1^.FSortDisable:=True;
  PNumber2:=New(PNumberCollection,Init(10,10));    PNumber2^.FSortDisable:=True;
  PNumber3:=New(PNumberCollection,Init(10,10));    PNumber3^.FSortDisable:=True;
  OverNumbers:=New(PNumberCollection,Init(10,10)); OverNumbers^.FSortDisable:=True;
  NoConfirm:=New(PNumberCollection,Init(10,10));   NoConfirm^.FSortDisable:=True;

  DateCollection:=New(PStringCollection,Init(10,10));


  CurrentDatePTR:=NewStr(DateToDateString('dd/mm',DateStringToDate('mm-dd',Date)));
  DateCollection^.Insert(CurrentDatePTR);

  TotalTariffTLG:=0;
  TotalInput:=0;
  TotalOutput:=0;
  OfDeleted:=0;
  OverR:=0;OverA:=0;OverS:=0;OverP:=0;OverB:=0;

  ReportStage:=rptScanning;
  CurrentItem:=1;
  ShowReportWindow;

  R.Assign(400,5,600,20);
  ReportInd:=New(PProcess,Init(R,Yellow,Red,White,True));
  If ReportWindow<>NIL
  Then Begin
       ReportWindow^.Insert(ReportInd);
       DisposeStr(ReportWindow^.Title);
       ReportWindow^.Title:=NewStr(Date);
       ReportWindow^.Frame^.DrawView;
       End
  Else Begin
       Dispose(ReportInd,Done);
       ReportInd:=NIL;
       End;
End;


Procedure StopReport;
Begin
  ReportStage:=rptNone;
  If DirStat<>Nil        Then Dispose(DirStat,Done);       DirStat:=nil;
  If ChanStat<>Nil       Then Dispose(ChanStat,Done);     ChanStat:=nil;
  If TariffStat<>Nil     Then Dispose(TariffStat,Done); TariffStat:=nil;

  PRegionsTraffic^.Stop;

  If ReportInd<>NIL      Then Dispose(ReportInd,Done);      ReportInd:=NIL;
  If PNumber1<>nil       Then Dispose(PNumber1,Done);       PNumber1:=nil;
  If PNumber2<>nil       Then Dispose(PNumber2,Done);       PNumber2:=nil;
  If PNumber3<>nil       Then Dispose(PNumber3,Done);       PNumber3:=nil;
  If OverNumbers<>nil    Then Dispose(OverNumbers,Done);    OverNumbers:=nil;
  If NoConfirm<>nil    Then Dispose(NoConfirm,Done);        NoConfirm:=nil;
  If DateCollection<>nil Then Dispose(DateCollection,Done); DateCollection:=nil;
End;

{}
{---                                                       ---}
{}
Function GetPeriod:String;
Var S:String;
Begin
  S:=DateToDateString('dd/mm',StartArchiveDate);
  If StartArchiveDate<>StopArchiveDate
  Then GetPeriod:='   '+S+'  '+DateToDateString('dd/mm',StopArchiveDate)
  Else GetPeriod:=' '+S;
End;

Procedure PrintCaption(isReport:TReport);
Var S:String;
Begin
  S:=ReportDirection;
  While S <> '' Do AddBufferLine(ParamIns(S,['<']));
  Case isReport of
    rptTariff:Begin
              AddBufferLine('   '+GetPeriod);
              AddBufferLine('');
              AddBufferLine(' ⮮⢥    ६   N       - (䭠 + )');
              CurrentExpl:='';
              End;
    rptSIT:Begin
           AddBufferLine('     '+GetPeriod);
           AddBufferLine(': '+Num2String(TotalOutput,6));
           AddBufferLine('');
           End;

    rptOverdue: Begin
                 AddBufferLine('    '+GetPeriod);
                 AddBufferLine(' '+
                 +' ='+Num2String(OverR,3)+' ='+Num2String(OverA,3)+
                 +' ='+Num2String(OverS,3)+' ='+Num2String(OverP,3)+
                 +' ='+Num2String(OverB,3)+
                 +'  '+Num2String(OverNumbers^.Count,1));
                 End;

    rptConfirm: Begin
                 AddBufferLine('    '+GetPeriod);
                 AddBufferLine(' '+Num2String(NoConfirm^.Count,1));
                 End;

 rptDirections : Begin
                 AddBufferLine('   '+GetPeriod);
                 AddBufferLine(
                        +' '+Num2String(TotalInput,6)+
                        +'  '+Num2String(TotalOutput,6)+
                        +'  '+Num2String(OfDeleted,6));

                 AddBufferLine('  ᯫ.            室                      室 ');
                 AddBufferLine('                                                     ');
                 End;

   rptChannels : Begin
                 AddBufferLine('   '+GetPeriod);
                 AddBufferLine(' '+Num2String(TotalInput,6)+
                              +'  '+Num2String(TotalOutput,6)+
                              +'  '+Num2String(OfDeleted,6));

                 AddBufferLine(' ᯫ. N                                   ');
                 AddBufferLine('           N N  /  /        N N  /  /      ');
                 End;

   rptRegions: Begin
                 AddBufferLine('    '+GetPeriod);
                 AddBufferLine('');
                 End;

  End;
End;

Procedure PrintAll(CurrentReport:TReport);
Var S:String;
    I,K:Word;
    P:PStatItem;
    Pt:PTariffItem;

    SinR,SoutR,
    SinA,SoutA,
    SinS,SoutS,
    SinP,SoutP,
    SinB,SoutB,
    SinSSS,SoutSSS,
    SStartOut,SEndOut,
    SStartIn,SEndIn:String[6];
    Var Current:Integer;
    PS:PString;
Begin
  If Not (CurrentReport in ReportKind.Reports) Then Exit;

  PrintCaption(CurrentReport);

  Case CurrentReport of
    rptTariff:
      Begin
        For Current:=1 To TariffStat^.Count
        Do Begin
           P:=TariffStat^.At(Current-1);

           If P^.Reply<>CurrentExpl
           Then Begin
                CurrentExpl:=P^.Reply;
                AddBufferLine('');
                AddBufferLine(AddLeft('ᯫ樮  : '+CurrentExpl,10));
                AddBufferLine(AddLeft('-----------------------------------',10));
                End;

           If P^.TariffColl^.Count>1
           Then AddBufferLine('');

           { ⮨ ⤥쭮 ⥫ࠬ }
           For I:=1 to P^.TariffColl^.Count
           Do Begin
              S:='';
              Pt:=P^.TariffColl^.At(I-1);

              If I=1
              Then Begin S:=P^.Expl; While Length(S)<20 do S:=S+' '; End
              Else S:=AddLeft('',20);

              S:=S+DateToDateString(DatePicture,Pt^.DateTime.D)+' ';
              S:=S+TimeToTimeString(TimePicture,Pt^.DateTime.T)+' ';

              S:=S+IntToStr(Pt^.NumArc,4)+' '+Pt^.OutIndex+' '+
                  +IntToStr(Pt^.NumWords,4)+'     '+
                  +TrimLeft(IntToCost(Pt^.Account))+Currency;
              AddBufferLine(S);
              End;

              { ᥣ    }
              AddBufferLine(AddLeft('',21));
              AddBufferLine(AddLeft('ᥣ: ',21)+IntToStr(P^.TariffColl^.Count,2)+
                      +'. =  '+TrimLeft(IntToCost(Round(P^.TotalAccount/100)*100))+
                           +' ('+TrimLeft(IntToCost(Round(P^.TotalTariff/100)*100))+' + ' +
                                 TrimLeft(IntToCost(P^.TotalNDS))+')'+Currency);
              AddBufferLine('');
           End;

        {騩 ⮣}
  {               AddBufferLine('');
        AddBufferLine(' : '+IntToStr(TotalTariffTLG,3)+'. = '+
                     TrimLeft(IntToCost(Round(TotalAccount/100)*100))
               +' ('+TrimLeft(IntToCost(Round(TotalTariff/100)*100)) +' + ' +
                     TrimLeft(IntToCost(TotalNDS))+') '+Currency);}

        AddBufferLine('');
        AddBufferLine('');
      End;

    rptOverdue:
      Begin
        S:='';
        CurrentDatePTR:=nil;
        For k:=1 to OverNumbers^.Count do
          Begin

          I:=OverNumbers^.GetObject(k-1,Pointer(PS));
          If CurrentDatePTR<>PS
          Then Begin
               If S<>'' Then AddBufferLine(S);
               S:='';
               AddBufferLine('');
               AddBufferLine(' : '+PS^);
               CurrentDatePTR:=PS;
               End;

          S:=S+Num2String(I,1)+' ';
          If Length(S)>=64
          Then Begin
               AddBufferLine(S);
               S:='';
               End;
          End;

        If Length(S)>1 Then AddBufferLine(S);
        AddBufferLine('');
      End;

    rptConfirm:
      Begin
        S:='';
        CurrentDatePTR:=nil;
        For k:=1 to NoConfirm^.Count do
          Begin

          I:=NoConfirm^.GetObject(k-1,Pointer(PS));
          If CurrentDatePTR<>PS
          Then Begin
               If S<>'' Then AddBufferLine(S);
               S:='';
               AddBufferLine('');
               AddBufferLine(' : '+PS^);
               CurrentDatePTR:=PS;
               End;

          AddBufferLine(PNumber(NoConfirm^.At(Pred(K)))^.Str);
          End;
        AddBufferLine('');
      End;

    rptDirections:
      Begin
        For Current:=1 To DirStat^.Count
        Do Begin
           P:=DirStat^.At(Current-1);

           If (P^.InpR>0) or (P^.OutR>0) or
              (P^.InpA>0) or (P^.OutA>0) or
              (P^.InpS>0) or (P^.OutS>0) or
              (P^.InpP>0) or (P^.OutP>0) or
              (P^.InpB>0) or (P^.OutB>0) or
              (P^.InpSSS>0) or (P^.OutSSS>0)
           Then Begin
                {ਥ}
                If P^.InpR=0 Then SinR:='    ' Else SinR:=Num2String(P^.InpR,4);
                If P^.InpA=0 Then SinA:='    ' Else SinA:=Num2String(P^.InpA,4);
                If P^.InpS=0 Then SinS:='    ' Else SinS:=Num2String(P^.InpS,4);
                If P^.InpP=0 Then SinP:='    ' Else SinP:=Num2String(P^.InpP,4);
                If P^.InpB=0 Then SinB:='    ' Else SinB:=Num2String(P^.InpB,4);
                If P^.InpSSS=0 Then SinSSS:='    ' Else SinSSS:=Num2String(P^.InpSSS,4);

                {।}
                If P^.OutR=0 Then SoutR:='    ' Else SoutR:=Num2String(P^.OutR,4);
                If P^.OutA=0 Then SoutA:='    ' Else SoutA:=Num2String(P^.OutA,4);
                If P^.OutS=0 Then SoutS:='    ' Else SoutS:=Num2String(P^.OutS,4);
                If P^.OutP=0 Then SoutP:='    ' Else SoutP:=Num2String(P^.OutP,4);
                If P^.OutB=0 Then SoutB:='    ' Else SoutB:=Num2String(P^.OutB,4);
                If P^.OutSSS=0 Then SoutSSS:='    ' Else SoutSSS:=Num2String(P^.OutSSS,4);


                S:=' '+P^.Expl+' '+SinR+' '+SinA+' '+SinS+' '+SinP+' '+SinB+' '+SinSSS+'  '
                                  +SoutR+' '+SoutA+' '+SoutS+' '+SoutP+' '+SoutB+' '+SoutSSS;
                AddBufferLine(S);
                End;
           End;

        AddBufferLine('');
        AddBufferLine('');
      End;

    rptSIT:
      Begin
        AddBufferLine('७  '
                  +Num2String(PNumber3^.Count,1)+' :');
        S:='';

        CurrentDatePTR:=nil;
        For k:=1 to PNumber3^.Count do
          Begin
          I:=PNumber3^.GetObject(k-1,Pointer(PS));

          If CurrentDatePTR<>PS
          Then Begin
               If S<>'' Then AddBufferLine(S);
               S:='';
               AddBufferLine('');
               AddBufferLine(' : '+PS^);
               CurrentDatePTR:=PS;
               End;

          S:=S+Num2String(I,1)+' ';
          If Length(S)>=64
          Then Begin
               AddBufferLine(S);
               S:='';
               End;
          End;
          If Length(S)>1 Then AddBufferLine(S);
          AddBufferLine('');

        AddBufferLine(' ந஢ '
                 +Num2String(PNumber1^.Count,1)+' :');
        S:='';
        CurrentDatePTR:=nil;
        For k:=1 to PNumber1^.Count do
          Begin
          I:=PNumber1^.GetObject(k-1,Pointer(PS));

          If CurrentDatePTR<>PS
          Then Begin
               If S<>'' Then AddBufferLine(S);
               S:='';
               AddBufferLine('');
               AddBufferLine(' : '+PS^);
               CurrentDatePTR:=PS;
               End;

          S:=S+Num2String(I,1)+' ';
          If Length(S)>=64
          Then Begin
               AddBufferLine(S);
               S:='';
               End;
          End;
          If Length(S)>1 Then AddBufferLine(S);
          AddBufferLine('');


        AddBufferLine('  ந஢ '
                  +Num2String(PNumber2^.Count,1)+' :');
        S:='';
        CurrentDatePTR:=nil;
        For k:=1 to PNumber2^.Count do
          Begin
          I:=PNumber2^.GetObject(k-1,Pointer(PS));

          If CurrentDatePTR<>PS
          Then Begin
               If S<>'' Then AddBufferLine(S);
               S:='';
               AddBufferLine('');
               AddBufferLine(' : '+PS^);
               CurrentDatePTR:=PS;
               End;

          S:=S+Num2String(I,1)+' ';
          If Length(S)>=64
          Then Begin
               AddBufferLine(S);
               S:='';
               End;
          End;

        If Length(S)>1 Then AddBufferLine(S);
        AddBufferLine('');
      End;

    rptChannels:
      Begin
        For Current:=1 To ChanStat^.Count
        Do Begin
           P:=ChanStat^.At(Current-1);

           If (P^.InpR>0) or (P^.OutR>0) or
              (P^.InpA>0) or (P^.OutA>0) or
              (P^.InpS>0) or (P^.OutS>0) or
              (P^.InpP>0) or (P^.OutP>0) or
              (P^.InpB>0) or (P^.OutB>0) or
              (P^.InpSSS>0) or (P^.OutSSS>0)
           Then Begin

                If P^.Expl = '    '
                Then Begin
                     P^.StartOutNum:=$FFFF;
                     P^.EndOutNum:=$FFFF;
                     P^.StartInpNum:=$FFFF;
                     P^.EndInpNum:=$FFFF;
                     End;

                If (P^.StartOutNum=0)
                   And (P^.EndOutNum=9999)
                Then Begin
                     SStartOut:=Num2String(P^.StartOutNum1,4);
                     SEndOut:=Num2String(P^.EndOutNum1,4);
                     End
                Else Begin
                     If P^.StartOutNum<>$FFFF
                     Then SStartOut:=Num2String(P^.StartOutNum,4)
                     Else SStartOut:='    ';
                     If P^.EndOutNum<>$FFFF
                     Then SEndOut:=Num2String(P^.EndOutNum,4)
                     Else SEndOut:='    ';
                     End;


                If (P^.StartInpNum=0)
                   And (P^.EndInpNum=9999)
                Then Begin
                     SStartIn:=Num2String(P^.StartInpNum1,4);
                     SEndIn:=Num2String(P^.EndInpNum1,4);
                     End
                Else Begin
                     If P^.StartInpNum<>$FFFF
                     Then SStartIn:=Num2String(P^.StartInpNum,4)
                     Else SStartIn:='    ';

                     If P^.EndInpNum<>$FFFF
                     Then SEndIn:=Num2String(P^.EndInpNum,4)
                     Else SEndIn:='    ';
                     End;

               P^.InpR:=P^.InpR+P^.InpA; P^.OutR:=P^.OutR+P^.OutA;
               P^.InpP:=P^.InpP+P^.InpB; P^.OutP:=P^.OutP+P^.OutB;

               If P^.InpR=0 Then SinR:='    ' Else SinR:=Num2String(P^.InpR,4);
               If P^.InpP=0 Then SinP:='    ' Else SinP:=Num2String(P^.InpP,4);
               If P^.InpS=0 Then SinS:='    ' Else SinS:=Num2String(P^.InpS,4);
               If P^.InpSSS=0 Then SinSSS:='    ' Else SinSSS:=Num2String(P^.InpSSS,4);

               If P^.OutR=0 Then SoutR:='    ' Else SoutR:=Num2String(P^.OutR,4);
               If P^.OutP=0 Then SoutP:='    ' Else SoutP:=Num2String(P^.OutP,4);
               If P^.OutS=0 Then SoutS:='    ' Else SoutS:=Num2String(P^.OutS,4);
               If P^.OutSSS=0 Then SoutSSS:='    ' Else SoutSSS:=Num2String(P^.OutSSS,4);


                S:=P^.Expl+' '+SStartIn +' '+SEndIn +' '+
                   +SinR +' '+ SinP+' '+SinS+' '+SinSSS+'   '+
                   +SStartOut+' '+SEndOut+' '+
                   +SoutR+' '+SoutP+' '+SoutS+' '+SOutSSS;
                AddBufferLine(S);
                End;
           End;
        AddBufferLine('');
        AddBufferLine('');
      End;

    rptRegions: PRegionsTraffic^.Print;

  End;
End;

Procedure ScanArchive;
Var I,k:Word;
    S:String;
    F:File;
    TSize:LongInt;
    Expl:String;
    PNum:PNumber;
Begin
  TSize:=TapeSize(CurrentArchive);
  If CurrentItem>TSize
  Then Begin
       If CurrentArchiveDate<StopArchiveDate
       Then Begin
            CurrentArchiveDate:=IncDate(CurrentArchiveDate,1,0,0);
            CurrentItem:=1;
            Date:=GetDateFileName(CurrentArchiveDate);
            If Assigned(ReportWindow)
            Then Begin
                 DisposeStr(ReportWindow^.Title);
                 ReportWindow^.Title:=NewStr(Date);
                 ReportWindow^.Frame^.DrawView;
                 End;

            CurrentArchive:=GetJnlPath(Date,IsNet);

            CurrentDatePTR:=NewStr(DateToDateString('dd/mm',DateStringToDate('mm-dd',Date)));
            DateCollection^.Insert(CurrentDatePTR);
            End
       Else ReportStage:=rptPrint;
       Exit;
       End;

  {If TSize=0 Then Exit;}
  ReportInd^.Update(Round ((CurrentItem/TSize) * 100));
  If TapeGet(CurrentArchive,ArcItem,CurrentItem)
  Then With ArcItem.System Do
       Begin

          {--- ࠡ⪠ ஢ ----}
          If rptTariff in ReportKind.Reports
          Then Begin
               If (Account>0) and (Flags and mfRepeated =0) and (Stage in [Transmitted,CheckWait])
               Then TariffStat^.AddTariff(FilterReply(InReply),InChannelExpl,CurrentItem,NumWords,Account,
                     NDSValue,MIndex,InDate);
               End;

          {--- ࠡ⪠ ஢ ----}
          If (rptSIT in ReportKind.Reports) and
             (Stage in [Transmitted,CheckWait]) and
             (Flags and mfRepeated =0)
          Then If Flags and (mfIndexed+mfAutoIndexed) > 0
               Then Begin
                    If Flags and mfIndexed > 0
                    Then Begin
                         If MIndex=Index_Own+'911'
                         Then PNumber2^.Insert(New(PNumber,InitObject(CurrentItem,CurrentDatePTR)))
                         Else PNumber1^.Insert(New(PNumber,InitObject(CurrentItem,CurrentDatePTR)));
                         End
                    Else If Flags and mfAutoIndexed >0
                         Then PNumber3^.Insert(New(PNumber,InitObject(CurrentItem,CurrentDatePTR)));
                    End;

          {---  ⨪  ࠢ ---}
          If rptDirections in ReportKind.Reports
          Then Begin
               {ਥ}
               If (Flags and (mfRepeated+mfDuplicated) = 0)
                 and (Date=DateToDateString('mm-dd',InDate.D))
               Then Begin
                    Expl:=AddRight(Copy(InChannelExpl,1,6),6);
                    If (Flags and mfReceiveSrv = mfReceiveSrv)
                    Then Expl:='+'+Expl
                    Else Expl:=' '+Expl;
                    DirStat^.AddInput(Expl,Category,InNumber);
                    End;
               {।}
               If (Stage = Transmitted) and (Flags and mfRepeated = 0)
                 and (Date=DateToDateString('mm-dd',OutDate.D))
               Then Begin
                    Expl:=AddRight(Copy(OutChannelExpl,1,6),6);
                    If (Flags and mfTransmitSrv = mfTransmitSrv)
                    Then Expl:='+'+Expl
                    Else Expl:=' '+Expl;
                    DirStat^.AddOutput(Expl,Category,OutNumber);
                    End;
               End;

          {---  ⨪   ---}
          If rptChannels in ReportKind.Reports
          Then Begin
               {ਥ}
               If (Flags and (mfRepeated+mfDuplicated) = 0)
                 and (Date=DateToDateString('mm-dd',InDate.D))
               Then Begin
                    Expl:=AddRight(InChannelExpl,9);
                    If (Flags and mfReceiveSrv = mfReceiveSrv)
                    Then Expl:='+'+Expl
                    Else Expl:=' '+Expl;
                    ChanStat^.AddInput(Expl,Category,InNumber);
                    End;
               {।}
               If (Stage = Transmitted) and (Flags and mfRepeated = 0)
                 and (Date=DateToDateString('mm-dd',OutDate.D))
               Then Begin
                    Expl:=AddRight(OutChannelExpl,9);
                    If (Flags and mfTransmitSrv = mfTransmitSrv)
                    Then Expl:='+'+Expl
                    Else Expl:=' '+Expl;
                    ChanStat^.AddOutput(Expl,Category,OutNumber);
                    End;
               End;

          {-- ࠡ⪠ 祭 --}
          If rptOverDue in ReportKind.Reports
          Then If Flags and mfOverdued >0
               Then Begin
                    Case Category[1] of
                      '': Inc(OverR);
                      '': Inc(OverA);
                      '': Inc(OverS);
                      '': Inc(OverP);
                      '': Inc(OverB);
                    End;
                    OverNumbers^.Insert(New(PNumber,InitObject(CurrentItem,CurrentDatePTR)));
                    End;

          {-- ࠡ⪠  ⢥ত --}
          If rptConfirm in ReportKind.Reports
          Then If Flags and mfNoConfirmed >0
               Then Begin
                    PNum:=New(PNumber,InitObject(CurrentItem,CurrentDatePTR));
                    PNum^.Str:= Category+MIndex+' '
                    +' '+InChannelExpl+' '+Num2String(InNumber,4)+' '+
                    +TimeToTimeString('hhmm',InDate.T)+' '+
                    +DateToDateString('dd.mm',InDate.D)+' '
                    +FilterReply(InReply)+
                    '  '+OutChannelExpl+' '+Num2String(OutNumber,4)+
                    +' '+TimeToTimeString('hhmm',OutDate.T)+' '+
                    +DateToDateString('dd.mm',OutDate.D)+' '+
                    +FilterReply(OutReply);
                    NoConfirm^.Insert(PNum);
                    End;

          {---  ⨪  ॣ  ---}
          If (rptRegions in ReportKind.Reports)
          Then PRegionsTraffic^.Add(ArcItem.System,Date);

          {---  饣 ⢠ ---}
          If Category<>''
          Then Begin
               {饥 - ਭ}
               If (Flags and (mfRepeated+mfDuplicated+mfReceiveSrv) = 0)
                 and (Date=DateToDateString('mm-dd',InDate.D))
               Then Inc(TotalInput);

               {饥 - ।}
               If (Stage = Transmitted)
                 and (Flags and (mfRepeated+mfTransmitSrv) = 0)
                 and (Date=DateToDateString('mm-dd',OutDate.D))
               Then Inc(TotalOutput);

               {饥 - 㤠}
               If Stage = Deleted
               Then Inc(OfDeleted);

               End;

          {--- 室  ᫥饩  ---}
          Inc(CurrentItem);
       End
  Else Begin
       MyError('ୠ: 訡 '+IntToStr(DiskResult,1));
       StopReport;
       End;
End;

Procedure IdleReport;
Begin
  If ReportStage=rptNone Then Exit;

  {஢ઠ  稥 }
  If MemAvail<MemoryLimit
  Then Begin
       AddBufferLine('   墠⠥  !');
       StopReport;
       End;

  Case ReportStage of
    rptScanning     : ScanArchive;
    rptPrint        : Begin
                      GetMem(Buffer,10000);
                      BufferPos:=1;

                      PrintAll(rptDirections);
                      PrintAll(rptChannels);
                      PrintAll(rptOverdue);
                      PrintAll(rptSIT);
                      PrintAll(rptTariff);
                      PrintAll(rptConfirm);
                      PrintAll(rptRegions);

                      StopReport;

                      If Assigned(ReportWindow)
                      Then Begin
                           DisposeStr(ReportWindow^.Title);
                           ReportWindow^.Title:=NewStr(' ⮢');
                           ReportWindow^.AddBuffer(Buffer,Pred(BufferPos));
                           ReportWindow^.DrawView;
                           End;

                      FreeMem(Buffer,10000);
                      End;
  End;
End;

Procedure MakeReport;
Type TDialogData=Record
     RepType:Word;
     StartTime,EndTime:TDateTime;
     End;

Var DData:TDialogData;
    D:PsDialog;
    IL:PsInputLine;
Begin
  DData.RepType:=0;
  DateToDMY(SystemDate,Integer(DData.StartTime.Day),Integer(DData.StartTime.Month),Integer(DData.StartTime.Year));
  DateToDMY(SystemDate,Integer(DData.EndTime.Day),Integer(DData.EndTime.Month),Integer(DData.EndTime.Year));
  D:=PsDialog(GetResource('DLG_ReportType'));
  If D=nil Then Exit;

  IL:=FindGroupItem(D,10);
  If IL<>nil Then IL^.Validator:=New(PMyDateValidator,Init{Small});

  IL:=FindGroupItem(D,11);
  If IL<>nil Then IL^.Validator:=New(PMyDateValidator,Init{Small});

  D^.SetData(DData);
  If DeskTop^.ExecView(D)=cmOk
  Then Begin
       D^.GetData(DData);
       ReportKind.Reports:=[];
       If DData.RepType and $0001  = $0001 Then ReportKind.Reports:= ReportKind.Reports + [rptDirections];
       If DData.RepType and $0002  = $0002 Then ReportKind.Reports:= ReportKind.Reports + [rptChannels];
       If DData.RepType and $0004  = $0004 Then ReportKind.Reports:= ReportKind.Reports + [rptOverdue];
       If DData.RepType and $0008  = $0008 Then ReportKind.Reports:= ReportKind.Reports + [rptSIT];
       If DData.RepType and $0010  = $0010 Then ReportKind.Reports:= ReportKind.Reports + [rptTariff];
       If DData.RepType and $0020  = $0020 Then ReportKind.Reports:= ReportKind.Reports + [rptConfirm];
       If DData.RepType and $0040  = $0040 Then ReportKind.Reports:= ReportKind.Reports + [rptRegions];

       StartArchiveDate:=DMYToDate(DData.StartTime.Day,DData.StartTime.Month,DData.StartTime.Year);
       StopArchiveDate:=DMYToDate(DData.EndTime.Day,DData.EndTime.Month,DData.EndTime.Year);
       CurrentArchiveDate:=StartArchiveDate;

       StartReport;
       End;
  Dispose(D,Done);
End;

{ TRegionsTrafficList =======================================================}

type
  TRegionsTraffic=record
    Name,Expl:string;
    Item:PStatColl;
    end;

procedure TRegionsTrafficList.LoadList;
var f:text; s,r:string; rec:TRegionsTraffic;
begin

  Assign(f,GetIDBPath('zregions.ini',IsNet));
  Reset(f); if IOResult <> 0 then Exit;

  PItems:=New(PList,Init);
  r:='?';

  while not Eof(f) do
    begin
    readln(f,s);
    if IOResult <> 0 then Exit;
    if pos(';',s) > 0 then Continue;
    s:=StrUpCase(StrSpaceFiltration(StrSpaceAppend(s)));

    if pos('#',s) = 1 then
      begin { ନ஢   ⭮ ॣ }
      Delete(s,1,1);
      rec.Name:=ParamIns(s,['=']);
      rec.Expl:=s;
      rec.Item:=nil;
      PItems^.InsertOne(rec,SizeOf(rec),PItems^.Fill);
      Continue;
      end;

    {    ॣ }
    if pos('*',s) = 1 then r:=Copy(s,2,Length(s)) else s:=r+'='+s;
    InsertOne(s,succ(Length(s)),Fill);
    end;
end;

function TRegionsTrafficList.Region(Index:String):String;
var i,n:word; s,item:string; k:byte;
begin

  Region:=Index+'?';
  if Length(Index)=0 then Exit;

  repeat
    item:=Index;
    for i:=1 to Fill do
      begin
      GetOne(s,n,pred(i));
      repeat
        if Pos('='+item,s)>0
        then begin
             Region:=ParamIns(s,['=']);
             Exit;
             end;
        k:=Pos(' ',item);
        if k > 0 then item:=Copy(item,succ(k),Length(item));
      until k=0;
      end;
    if Pos('02 ',Index)>0 then Index:=Copy(Index,4,Length(Index));
    if Length(Index)>3 then Index:=Copy(Index,1,3) else Exit;
  until False;

end;

procedure TRegionsTrafficList.Start;
var i:integer; n:word; p: pointer;
begin
  for i:=1 to PItems^.Fill
  do begin
     PItems^.GetOnePtr(p,n,pred(i));
     if TRegionsTraffic(p^).Item<>nil
     then Dispose(TRegionsTraffic(p^).Item,Done);
     TRegionsTraffic(p^).Item:=New(PStatColl,Init(10,10));
     end;
end;

procedure TRegionsTrafficList.Stop;
var i:integer; n:word; p:pointer;
begin
  for i:=1 to PItems^.Fill
  do begin
     PItems^.GetOnePtr(p,n,pred(i));
     if TRegionsTraffic(p^).Item<>nil
     then Dispose(TRegionsTraffic(p^).Item,Done);
     TRegionsTraffic(p^).Item:=nil;
     end;
end;

procedure TRegionsTrafficList.Add(Sys:SystemMessageRec; Date:String);
var i:integer; n:word; p:pointer; inpid,outid:String;
begin
with Sys do
  begin

  if (Category='') or ((Flags and mfRepeated)<>0)
    or (Stage<>Transmitted) or (Date<>DateToDateString('mm-dd',OutDate.D))
  then Exit;

  for i:=1 to PItems^.Fill
  do begin
     PItems^.GetOnePtr(p,n,pred(i));
     with TRegionsTraffic(p^) do
       begin
       if (Length(Expl)=0) or (Pos(Index_Own,Expl)=1)
       then begin
            inpid:=Source;
            outid:=MIndex;
            end
       else begin
            inpid:=MIndex;
            outid:=Source;
            end;
       {ਥ}
       if (Length(Expl)=0) and (Flags and (mfDuplicated+mfReceiveSrv)=0)
         or (Length(Expl)>0) and (Expl=Copy(OutChannelExpl,1,6))
       then Item^.AddInput(AddRight(Copy(Region(inpid),1,15),15),Category,0);
       {।}
       if (Length(Expl)=0) and ((Flags and mfTransmitSrv)=0)
         or (Length(Expl)>0) and (Expl=Copy(InChannelExpl,1,6))
       then Item^.AddOutput(AddRight(Copy(Region(outid),1,15),15),Category,0);
       end;
     end;
  end;
end;

procedure TRegionsTrafficList.Print;
var i,k:integer;
    n:word;
    pt:pointer;
    S:String;
    P:PStatItem;
    SinR,SoutR,SinA,SoutA,SinS,SoutS,SinP,SoutP,SinAll,SoutAll:String[6];
begin
  for i:=1 to PItems^.Fill
  do begin
     PItems^.GetOnePtr(pt,n,pred(i));

     AddBufferLine(TRegionsTraffic(pt^).Name);
     AddBufferLine('                  室                   室');
     AddBufferLine('                             /  ᥣ              /  ᥣ');

     for k:=1 To TRegionsTraffic(pt^).Item^.Count
     do begin
        P:=TRegionsTraffic(pt^).Item^.At(k-1);

        If (P^.InpR>0) or (P^.OutR>0) or
           (P^.InpA>0) or (P^.OutA>0) or
           (P^.InpS>0) or (P^.OutS>0) or
           (P^.InpP>0) or (P^.OutP>0) or
           (P^.InpB>0) or (P^.OutB>0)
        Then Begin
             {ਥ}
             If P^.InpR=0 Then SinR:='   ' Else SinR:=Num2String(P^.InpR,3);
             If P^.InpA=0 Then SinA:='   ' Else SinA:=Num2String(P^.InpA,3);
             If P^.InpS=0 Then SinS:='     ' Else SinS:=Num2String(P^.InpS,5);
             If P^.InpP+P^.InpB=0 Then SinP:='     ' Else SinP:=Num2String(P^.InpP+P^.InpB,5);
             SinAll:=Num2String(P^.InpR+P^.InpA+P^.InpS+P^.InpP+P^.InpB,5);
             {।}
             If P^.OutR=0 Then SoutR:='   ' Else SoutR:=Num2String(P^.OutR,3);
             If P^.OutA=0 Then SoutA:='   ' Else SoutA:=Num2String(P^.OutA,3);
             If P^.OutS=0 Then SoutS:='     ' Else SoutS:=Num2String(P^.OutS,5);
             If P^.OutP+P^.OutB=0 Then SoutP:='     ' Else SoutP:=Num2String(P^.OutP+P^.OutB,5);
             SoutAll:=Num2String(P^.OutR+P^.OutA+P^.OutS+P^.OutP+P^.OutB,5);

             AddBufferLine(' '+P^.Expl+' '+SinR+' '+SinA+' '+SinS+' '+SinP+' '
               +SinAll+'  '+SoutR+' '+SoutA+' '+SoutS+' '+SoutP+' '+SoutAll);
             End;
        End;

     AddBufferLine('');
     end;

   AddBufferLine('');

end;

destructor TRegionsTrafficList.Done;
begin
Stop;
PItems^.Done;
inherited Done;
end;

{====================================================================}

Begin
  ReportStage:=rptNONE;
  ReportKind.Reports:=[];

  DirStat:=NIL;
  ChanStat:=NIL;
  TariffStat:=NIL;

  ReportInd:=NIL;
  PNumber1:=Nil;
  PNumber2:=Nil;
  PNumber3:=Nil;
  OverNumbers:=NIL;
  DateCollection:=Nil;
  NoConfirm:=NIL;
End.